<?php

if (!$_REQUEST) {
   $_REQUEST = $_POST;
}

$done = false;

if (!function_exists("readThrough")) {
   function readThrough($file) {
      $fp = @fopen($file, "r");
      $contents = "";
      while (!@feof($fp)) {
         $contents .= @fread($fp, 1024);
      }
      @fclose($fp);
      return $contents;
   }
}

if (!function_exists("writeThrough")) {
   function writeThrough($file, $contents) {

      if (is_array($contents)) {
         $contents = implode("\n", $contents);
      }

      $fp = fopen($file, "w");
      fwrite($fp, $contents);
      fclose($fp);
   }
}

$mysql_server = $_REQUEST["mysql_server"];
if (!$mysql_server) $mysql_server = "localhost";

$mysql_user = $_REQUEST["mysql_user"];
$mysql_password = $_REQUEST["mysql_password"];
$mysql_db = $_REQUEST["mysql_db"];
$table = "leech_list";

$folder = $_SERVER["DOCUMENT_ROOT"] . dirname($_SERVER["SCRIPT_NAME"]);
$htaccess = array(
   "AddType application/x-httpd-php .html .htm",
   "php_value auto_prepend_file \"$folder/crawl.php\""
);

$htaccess = implode("\n", $htaccess);

$ready = ($mysql_server && $mysql_user && $mysql_password && $mysql_db);

if ($ready) {

   if (file_exists("db.php") and filesize("db.php") > 0) {
      //$error = ("Delete the db.php file to reinstall.");
   }

   if (!@is_writable("db.php") and !@touch("db.php")) {
      $error = "Please chmod this folder to 777, and db.php to 777, to begin the install.";
   }

   if (!@is_writable("crawl.php")) {
      $error = "Please chmod crawl.php to 777.";
   }

   if (!@mysql_connect($mysql_server, $mysql_user, $mysql_password)) {
      $error = ("Couldn't connect to mySQL.  Please check your username and password.");
   }

   if (!@mysql_select_db($mysql_db)) {
      $error = ("Connected but couldn't select database.  Make sure the database exists and that you've granted the user " . $mysql_user . " access to this database in your control panel.");
   }

   if (!$error) {

      // Write to the database
      mysql_query("DROP TABLE IF EXISTS $table") or die(mysql_error());
      mysql_query("DROP TABLE IF EXISTS `leech_quotas`;") or die(mysql_error());

      mysql_query("CREATE TABLE `leech_list` (  `ip` int(16) NOT NULL default '0',  `timestamp` int(11) NOT NULL default '0',  KEY `ip` (`ip`),  KEY `timestamp` (`timestamp`)) TYPE=MyISAM;") or die(mysql_error());

      mysql_query("CREATE TABLE `leech_quotas` (  `ip` int(16) NOT NULL default '0',  `lastFlush` int(11) NOT NULL default '0',  `total` int(11) NOT NULL default '0',  `hostname` varchar(255) NOT NULL default '',  `isProxy` int(1) NOT NULL default '0',  `challenge` varchar(6) NOT NULL default '',  PRIMARY KEY  (`ip`),  KEY `lastFlush` (`lastFlush`)) TYPE=MyISAM;") or die(mysql_error());

      $error = mysql_error();

      // Write to the db file
      $contents = array(
         '<' . '?php',
         '',

         '$mysql_hostname = "' . $mysql_server . '";',
         '$mysql_username = "' . $mysql_user . '";',
         '$mysql_password = "' . $mysql_password . '";',
         '$mysql_database = "' . $mysql_db . '"; ',

         '',
         '?' . '>'

      );

      // Write to htaccess, or display copy and paste code if we can't

      writeThrough("htaccess.txt", $htaccess);
      writeThrough("db.php", $contents);

      $crawlFile = readThrough("crawl.php");
      $crawlFile = preg_replace('/\$path = "(.*)";/i', '$path = "'. $folder . '";', $crawlFile);
      writeThrough("crawl.php", $crawlFile);

      if (is_writable(".htaccess") or @touch(".htaccess")) {
         writeThrough(".htaccess", $htaccess);
      }

      else { ?>
      <p><b>Copy and paste this into your .htaccess file:</b></p>

      <pre><?=($htaccess)?></pre>

      <p>Place that in a new text file and save as &quot;.htaccess&quot; WITH the dot in front.  Upload to your server.</p>
      <? }

   }

}

if (!$ready or $error) {
?>

<form action="<?=$_SERVER["PHP_SELF"]?>" method="post">

<h2 align="center">AntiCrawl Installer</h2>

<h3><?=$error?></h3>

<div align="center">
<table border="1">
<tr>
<td>mySQL server:</td>
<td><input type="text" name="mysql_server" value="<?=$mysql_server?>"></td>
</tr>

<tr>
<td>mySQL username:</td>
<td><input type="text" name="mysql_user" value="<?=$mysql_user?>"></td>
</tr>

<tr>
<td>mySQL password:</td>
<td><input type="text" name="mysql_password" value="<?=$mysql_password?>"></td>
</tr>

<tr>
<td>mySQL database:</td>
<td><input type="text" name="mysql_db" value="<?=$mysql_db?>"></td>
</tr>

<tr>
<td colspan="2" align="center"><input type="submit" value="Install"></td>
</tr>

</table>
</div>

</form>

<?
}

else {
?>
<h1>Installation Complete!</h1>

<p>Your site is now partly protected from site scrapers.  Copy the htaccess.txt file in this folder to any folder of your site you want protected, and rename it to &quot;.htaccess&quot; (WITH the dot in front.)
<?
}

?>